using System;
using System.Threading;

using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;

using GHIElectronics.NETMF.FEZ;

using I2CExtensions;

namespace FEZ_Domino_I2C_scanner
{
    public class Program
    {

        public static I2CDevice.Configuration I2C_dev;   //device
        public static I2CDevice I2CcommBus;   // One bus

        public static int result;

        public static void Main()
        {
 
            int I2C_ClockRate = 100;

            I2CcommBus = new I2CDevice(I2C_dev);

            int start_address = 0;
            int end_address = 255;

            int address;

            Debug.Print("\nI2C scanner ready....\n");
            Debug.Print("Startaddress is: " + start_address.ToString());
            Debug.Print("Endaddress   is: " + end_address.ToString() + "\n");

 
            for (address = start_address; address < end_address; address++)
            {
                I2C_dev = new I2CDevice.Configuration((ushort)(address >> 1), I2C_ClockRate);

                I2C_Write(address, 0x00);
            }

        }

        public static void I2C_Write(int Address, byte data)    // I2C write method
        {
            var xActions = new I2CDevice.I2CTransaction[1];
            xActions[0] = I2CDevice.CreateWriteTransaction(new byte[] { (byte)(Address >> 8), (byte)(Address & 0xFF), data });
            result = I2CcommBus.NewExecute(I2C_dev, xActions, 1000);    // Using extension method
            if (result != 0)
            {
                Debug.Print("Address : " + Address.ToString() + " - result is: " + result.ToString());
            }
            Thread.Sleep(5); // Mandatory after each Write transaction !!!
        }
    }
}