using Microsoft.SPOT.Hardware;


namespace System.Runtime.CompilerServices 
{ 
    [AttributeUsage(AttributeTargets.Assembly | AttributeTargets.Class | AttributeTargets.Method)] 
    public sealed class ExtensionAttribute : Attribute { } 
} 

namespace I2CExtensions
{



    public static class I2CBus
    {

        public static int NewExecute(this I2CDevice pDev,  I2CDevice.Configuration pConfig, I2CDevice.I2CTransaction[] xActions, int timeout)
        {
            var ConfigSav = pDev.Config;
            pDev.Config = pConfig;
            var RetVal = pDev.Execute(xActions, timeout);
            pDev.Config = ConfigSav;
            return RetVal;
        }
            
        public static void Broadcast(this I2CDevice pDev, I2CDevice.Configuration[] pConf, I2CDevice.I2CTransaction[] xActions, int timeout)
        {
            var ConfigSav = pDev.Config;
            foreach (I2CDevice.Configuration cnf in pConf)
            {
                pDev.Config = cnf;
                pDev.Execute(xActions, timeout);
            }
            pDev.Config = ConfigSav;
        }
    }

}
